//
//  SuccessBaseView.m
//  Open
//
//  Created by 雷俊博 on 2019/7/24.
//  Copyright © 2019 黄江涛 . All rights reserved.
//

#import "SuccessBaseView.h"
#import "Constants.h"
#import "UIColor+Hex.h"
#import "NSString+AttributedString.h"
#import "UIButton+ImageTitleSpacing.h"
#import <ZJAnimationPopView.h>

#import <Constants.h>

#define title1 [NSString stringWithFormat:@"我们家乡%@可以刷脸进行社保认证了。足不出村，足不出户；轻松认证，放心领钱！！",self.address]
#define title2 @"看看社保，科技惠民，科技便民，人工智能走入寻常百姓家。"

@interface SuccessBaseView ()


@property (nonatomic, copy)NSString *address;




@end

@implementation SuccessBaseView
#pragma mark - cycle
- (instancetype)initWithTitle:(NSString *)title name:(NSString *)name address:(NSString *)address type:(SocialType)type block:(CTClickBlock)block
{
    
    self = [super init];
    if (self) {
        self.lb_title.text = title;
        self.lb_name.text = name;
        self.address = address;
        self.state = type;
        self.block = block;
        [self initUI];
       
    }
    return self;
}

- (void)initUI
{
    self.frame =ScreenBounds;
    [self addSubview:self.backgroundView];
    [self addSubview:self.alertView];
    [self addSubview:self.img_title];
    [self addSubview:self.lb_title];
   
    [self setupUI];
}


- (void)setupUI
{
    
    
    [self.img_title mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.offset(127 * WIDTHRADIU);
        make.centerX.equalTo(self);
        make.width.offset(310 * WIDTHRADIU);
        make.height.offset(83 * WIDTHRADIU);
    }];
    
    [self.lb_title mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.offset(140 * WIDTHRADIU);
        make.centerX.equalTo(self);
        make.height.offset(24 * WIDTHRADIU);
    }];
    
    [self.alertView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.img_title).offset(10 * WIDTHRADIU);
         make.right.equalTo(self.img_title).offset(-10 * WIDTHRADIU);
        make.top.offset(161 * WIDTHRADIU);
        make.height.offset(410 * WIDTHRADIU);
    }];
    [self.lb_name mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.alertView);
        make.top.offset(43 * WIDTHRADIU);
        make.height.offset(25 * WIDTHRADIU);
    }];
    [self.dottedlineView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.offset(15 * WIDTHRADIU);
        make.right.offset(-15 * WIDTHRADIU);
        make.top.equalTo(self.lb_name.mas_bottom).offset(16 * WIDTHRADIU);
        make.height.offset(1);
    }];
    [self.lb_share mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.alertView);
        make.top.equalTo(self.dottedlineView.mas_bottom).offset(15 * WIDTHRADIU);
        make.height.offset(16 * WIDTHRADIU);
    }];
    [self.lb_shareContent mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.lb_share.mas_bottom).offset(15 * WIDTHRADIU);
//        make.left.offset(20 * WIDTHRADIU);
//        make.right.offset(-20 * WIDTHRADIU);
        make.centerX.equalTo(self.alertView);
        make.width.equalTo(self.dottedlineView.mas_width).offset(-10 * WIDTHRADIU);
        make.height.offset([NSString getSpaceLabelHeightwithSpeace:8 * WIDTHRADIU withFont:[UIFont systemFontOfSize:13 * WIDTHRADIU] withWidth:(self.dottedlineView.frame.size.width - 10 * WIDTHRADIU)  text:title1] +1);
    }];
    [self.lb_shareContent2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.alertView);
        make.width.equalTo(self.lb_shareContent.mas_width);
        make.top.equalTo(self.lb_shareContent.mas_bottom).offset(10 * WIDTHRADIU);
        make.height.offset([NSString getSpaceLabelHeightwithSpeace:8 * WIDTHRADIU withFont:[UIFont systemFontOfSize:13 * WIDTHRADIU] withWidth:(self.dottedlineView.frame.size.width - 10 * WIDTHRADIU)  text:title2] +1);
    }];
    
    [self.btn_WX mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.alertView).offset(-50 * WIDTHRADIU);
        make.top.equalTo(self.lb_shareContent2.mas_bottom).offset(15 * WIDTHRADIU);
        make.width.height.offset(80 * WIDTHRADIU);
    }];
    
    [self.btn_CircleFriends mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.alertView).offset(50 * WIDTHRADIU);
        make.top.equalTo(self.lb_shareContent2.mas_bottom).offset(15 * WIDTHRADIU);
        make.width.height.offset(80 * WIDTHRADIU);
    }];
    [self.btn_backHome mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.btn_WX.mas_bottom).offset(17 * WIDTHRADIU);
        make.centerX.equalTo(self.alertView);
    }];
    [self.leftLine mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.btn_backHome);
        make.right.equalTo(self.btn_backHome.mas_left).offset(-12 * WIDTHRADIU);
        make.width.offset(51 * WIDTHRADIU);
        make.height.offset(1);
    }];
    
    [self.rightLine mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.btn_backHome);
        make.left.equalTo(self.btn_backHome.mas_right).offset(12 * WIDTHRADIU);
        make.width.offset(51 * WIDTHRADIU);
         make.height.offset(1);
    }];
    
}

- (void)dealloc
{
    NSLog(@"SuccessBaseView被销毁");
}

#pragma mark - public methods
+ (void)showSuccessAlertViewWithTitle:(NSString *)title name:(NSString *)name address:(NSString *)address type:(SocialType)type block:(CTClickBlock)block
{
    SuccessBaseView *view = [[SuccessBaseView alloc]initWithTitle:title name:name address:address type:type block:block];
    
    [view showWithAnimation:YES];
}

#pragma mark - event response
-(void)didTapBackgroundView:(UITapGestureRecognizer *)sender
{
   
}

- (void)btnClick:(UIButton *)sender
{
   
    if (self.block) {
        self.block(sender.tag);
    }
    
    if (sender.tag == 202) {
        [self dismissWithAnimation:YES];
    }
}

#pragma mark - 弹出视图方法
- (void)showWithAnimation:(BOOL)animation
{
    
    //1.获取当前应用的主窗口
    UIWindow *keyWindow = [UIApplication sharedApplication].keyWindow;
    [keyWindow addSubview: self];
    if (animation) {
//        //动画前初始位置
//        CGRect rect = self.alertView.frame;
//        rect.origin.y = SCREEN_HEIGHT;
//        self.alertView.frame = rect;
        
        
    }
}

- (void)dismissWithAnimation:(BOOL)animation
{
    [self.lb_name removeFromSuperview];
    [self.dottedlineView removeFromSuperview];
    [self.lb_share removeFromSuperview];
    [self.lb_shareContent removeFromSuperview];
    [self.lb_shareContent2 removeFromSuperview];
    [self.btn_WX removeFromSuperview];
    [self.btn_CircleFriends removeFromSuperview];
    [self.btn_backHome removeFromSuperview];
    [self.leftLine removeFromSuperview];
    [self.rightLine removeFromSuperview];
    [self.alertView removeFromSuperview];
    [self.img_title removeFromSuperview];
    [self.lb_title removeFromSuperview];
    [self.backgroundView removeFromSuperview];
    [self removeFromSuperview];
    self.lb_name = nil;
    self.dottedlineView = nil;
    self.lb_share = nil;
    self.lb_shareContent = nil;
    self.lb_shareContent2 = nil;
    self.btn_WX = nil;
    self.btn_CircleFriends = nil;
    self.btn_CircleFriends = nil;
    self.leftLine = nil;
    self.rightLine = nil;
    self.alertView  = nil;
    self.lb_title = nil;
    self.img_title = nil;
    self.backgroundView = nil;
    
}

#pragma mark - getters and setters
- (UIView *)backgroundView
{
    if (!_backgroundView) {
        _backgroundView = [[UIView alloc]initWithFrame:ScreenBounds];
        _backgroundView.backgroundColor = [UIColor blackColor] ;
        _backgroundView.alpha = 0.3f ;
        _backgroundView.userInteractionEnabled = YES;
        UITapGestureRecognizer *myTap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(didTapBackgroundView:)];
        [_backgroundView addGestureRecognizer:myTap];
    }
     return _backgroundView;
}

- (UIImageView *)img_title
{
    if (!_img_title) {
        _img_title = [[UIImageView alloc]init];
        _img_title.image = [UIImage imageNamed:@"Socialsecuritycollection_success_title_normal"];
    }
    return _img_title;
}

- (UILabel *)lb_title
{
    if (!_lb_title) {
        _lb_title = [[UILabel alloc]init];
        _lb_title.text = @"恭喜采集成功";
        _lb_title.textColor = [UIColor whiteColor];
        _lb_title.font = [UIFont systemFontOfSize:24 * WIDTHRADIU];
        _lb_title.textAlignment = NSTextAlignmentCenter;
    }
    return _lb_title;
}

- (UIView *)alertView
{
    if (!_alertView) {
        _alertView = [[UIView alloc]init];
        _alertView.backgroundColor = [UIColor whiteColor];
        _alertView.layer.cornerRadius = 15 * WIDTHRADIU;
        _alertView.layer.masksToBounds = YES;
        [_alertView addSubview:self.lb_name];
        [_alertView addSubview:self.dottedlineView];
        [_alertView addSubview:self.lb_share];
        [_alertView addSubview:self.lb_shareContent];
        [_alertView addSubview:self.lb_shareContent2];
        [_alertView addSubview:self.btn_WX];
        [_alertView addSubview:self.btn_CircleFriends];
        [_alertView addSubview:self.btn_backHome];
        [_alertView addSubview:self.leftLine];
        [_alertView addSubview:self.rightLine];
    }
    return _alertView;
}

- (UILabel *)lb_name
{
    if (!_lb_name) {
        _lb_name = [[UILabel alloc]init];
        _lb_name.text = @"刘姥姥";
        _lb_name.textColor = [UIColor colorWithHex:0x4d4d4d];
        _lb_name.font = [UIFont boldSystemFontOfSize:25 * WIDTHRADIU];
        _lb_name.textAlignment = NSTextAlignmentCenter;
    }
    return _lb_name;
}

- (DashesLineView *)dottedlineView
{
    if (!_dottedlineView) {
        _dottedlineView = [[DashesLineView alloc]initWithFrame:CGRectMake(15 * WIDTHRADIU, 0, self.bounds.size.width - 30 * WIDTHRADIU, 1)];
        _dottedlineView.backgroundColor = [UIColor whiteColor];
    }
    return _dottedlineView;
}

- (UILabel *)lb_share
{
    if (!_lb_share) {
        _lb_share = [[UILabel alloc]init];
        _lb_share.text = @"分享APP";
        _lb_share.textColor = [UIColor colorWithHex:0x4d4d4d];
        _lb_share.font = [UIFont systemFontOfSize:16 * WIDTHRADIU];
    }
    return _lb_share;
}

- (UILabel *)lb_shareContent
{
    if (!_lb_shareContent) {
        _lb_shareContent = [[UILabel alloc]init];
        _lb_shareContent.textColor = [UIColor colorWithHex:0x808080];
        _lb_shareContent.numberOfLines = 0;
        _lb_shareContent.font = [UIFont systemFontOfSize:13 * WIDTHRADIU];
        _lb_shareContent.attributedText = [NSString stringWithParagraphlineSpeace:8 * WIDTHRADIU textColor:[UIColor colorWithHex:0x808080] textFont:[UIFont systemFontOfSize:13 * WIDTHRADIU] text:title1];
       
    }
    return _lb_shareContent;
}
- (UILabel *)lb_shareContent2
{
    if (!_lb_shareContent2) {
        _lb_shareContent2 = [[UILabel alloc]init];
        _lb_shareContent2.textColor = [UIColor colorWithHex:0x808080];
        _lb_shareContent2.numberOfLines = 0;
        _lb_shareContent2.font = [UIFont systemFontOfSize:13 * WIDTHRADIU];
        _lb_shareContent2.attributedText = [NSString stringWithParagraphlineSpeace:8 * WIDTHRADIU textColor:[UIColor colorWithHex:0x808080] textFont:[UIFont systemFontOfSize:13 * WIDTHRADIU] text:title2];
        
    }
    return _lb_shareContent2;
}

- (UIButton *)btn_WX
{
    if (!_btn_WX) {
        _btn_WX = [UIButton buttonWithType:UIButtonTypeCustom];
        [_btn_WX setImage:[UIImage imageNamed:@"Socialsecuritycollection_success_share_WeChat_normal"] forState:UIControlStateNormal];
        _btn_WX.titleLabel.font = [UIFont systemFontOfSize:15 * WIDTHRADIU];
        [_btn_WX setTitleColor:[UIColor colorWithHex:0x808080] forState:UIControlStateNormal];
        [_btn_WX setTitle:@"微信" forState:UIControlStateNormal];
        [_btn_WX layoutButtonWithEdgeInsetsStyle:GLButtonEdgeInsetsStyleTop imageTitleSpace:8 * WIDTHRADIU];
        _btn_WX.tag = 200;
        [_btn_WX addTarget:self action:@selector(btnClick:) forControlEvents:UIControlEventTouchUpInside];
    }
    return _btn_WX;
}
- (UIButton *)btn_CircleFriends
{
    if (!_btn_CircleFriends) {
        _btn_CircleFriends = [UIButton buttonWithType:UIButtonTypeCustom];
        [_btn_CircleFriends setImage:[UIImage imageNamed:@"Socialsecuritycollection_success_share_Circleoffriends_normal"] forState:UIControlStateNormal];
        _btn_CircleFriends.titleLabel.font = [UIFont systemFontOfSize:15 * WIDTHRADIU];
        [_btn_CircleFriends setTitleColor:[UIColor colorWithHex:0x808080] forState:UIControlStateNormal];
        [_btn_CircleFriends setTitle:@"朋友圈" forState:UIControlStateNormal];
        [_btn_CircleFriends layoutButtonWithEdgeInsetsStyle:GLButtonEdgeInsetsStyleTop imageTitleSpace:8 * WIDTHRADIU];
        
        _btn_CircleFriends.tag = 201;
        
         [_btn_CircleFriends addTarget:self action:@selector(btnClick:) forControlEvents:UIControlEventTouchUpInside];
       
    }
    return _btn_CircleFriends;
}

- (UIButton *)btn_backHome
{
    if (!_btn_backHome) {
        _btn_backHome = [UIButton buttonWithType:UIButtonTypeCustom];
        _btn_backHome.titleLabel.font = [UIFont systemFontOfSize:14 * WIDTHRADIU];
        [_btn_backHome setTitleColor:[UIColor colorWithHex:0x1886d3] forState:UIControlStateNormal];
        [_btn_backHome setTitle:@"返回首页" forState:UIControlStateNormal];
        _btn_backHome.tag = 202;
          [_btn_backHome addTarget:self action:@selector(btnClick:) forControlEvents:UIControlEventTouchUpInside];
    }
    return _btn_backHome;
}

- (UIView *)leftLine
{
    if (!_leftLine) {
        _leftLine = [[UIView alloc]init];
        _leftLine.backgroundColor = [UIColor colorWithHex:0x1886d3];
    }
    return _leftLine;
}
- (UIView *)rightLine
{
    if (!_rightLine) {
        _rightLine = [[UIView alloc]init];
        _rightLine.backgroundColor = [UIColor colorWithHex:0x1886d3];
    }
    return _rightLine;
}
/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
